diff --git a/admin/tool/filetypes/renderer.php b/admin/tool/filetypes/renderer.php
new file mode 100644
index 00000000000..dee5281585f
--- /dev/null
+++ b/admin/tool/filetypes/renderer.php
@@ -0,0 +1,179 @@
+<?php
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+/**
+ * Renderer.
+ *
+ * @package tool_filetypes
+ * @copyright 2014 The Open University
+ * @license http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+
+defined('MOODLE_INTERNAL') || die();
+
+/**
+ * Class containing the renderer functions for displaying file types.
+ *
+ * @package tool_filetypes
+ * @copyright 2014 The Open University
+ * @license http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+class tool_filetypes_renderer extends plugin_renderer_base {
+
+    /**
+     * Renderer for displaying the file type edit table.
+     *
+     * @param array $filetypes An array of file type objects (from get_mimetypes_array)
+     * @param array $deleted An array of deleted file types
+     * @param bool $restricted If true, cannot be edited because set in config.php.
+     * @return string HTML code
+     */
+    public function edit_table(array $filetypes, array $deleted, $restricted) {
+        // Get combined array of all types, with deleted marker.
+        $combined = array_merge($filetypes, $deleted);
+        foreach ($deleted as $ext => $value) {
+            $combined[$ext]['deleted'] = true;
+        }
+        ksort($combined);
+
+        $out = $this->heading(get_string('pluginname', 'tool_filetypes'));
+        if ($restricted) {
+            $out .= html_writer::div(
+                    html_writer::div(get_string('configoverride', 'admin'), 'form-overridden'),
+                    '', array('id' => 'adminsettings'));
+        }
+        if (count($combined) > 1) {
+            // Display the file type table if any file types exist (other than 'xxx').
+            $table = new html_table();
+            $headings = new html_table_row();
+            $headings->cells = array();
+            $headings->cells[] = new html_table_cell(get_string('extension', 'tool_filetypes'));
+            if (!$restricted) {
+                $headings->cells[] =
+                        new html_table_cell(html_writer::span(get_string('edit'), 'accesshide'));
+            }
+            $headings->cells[] = new html_table_cell(get_string('source', 'tool_filetypes'));
+            $headings->cells[] = new html_table_cell(get_string('mimetype', 'tool_filetypes'));
+            $headings->cells[] = new html_table_cell(get_string('groups', 'tool_filetypes'));
+            $headings->cells[] = new html_table_cell(get_string('displaydescription', 'tool_filetypes'));
+            foreach ($headings->cells as $cell) {
+                $cell->header = true;
+            }
+            $table->data = array($headings);
+            foreach ($combined as $extension => $filetype) {
+                if ($extension === 'xxx') {
+                    continue;
+                }
+                $row = new html_table_row();
+                $row->cells = array();
+
+                // First cell has icon and extension.
+                $icon = $this->pix_icon('f/' . $filetype['icon'], '');
+                $row->cells[] = new html_table_cell($icon . ' ' . html_writer::span(s($extension)));
+
+                // Reset URL and button if needed.
+                $reverturl = new \moodle_url('/admin/tool/filetypes/revert.php',
+                        array('extension' => $extension));
+                $revertbutton = html_writer::link($reverturl, $this->pix_icon('t/restore',
+                        get_string('revert', 'tool_filetypes', s($extension))));
+                if ($restricted) {
+                    $revertbutton = '';
+                }
+
+                // Rest is different for deleted items.
+                if (!empty($filetype['deleted'])) {
+                    // Show deleted standard types differently.
+                    if (!$restricted) {
+                        $row->cells[] = new html_table_cell('');
+                    }
+                    $source = new html_table_cell(get_string('source_deleted', 'tool_filetypes') .
+                            ' ' . $revertbutton);
+                    $source->attributes = array('class' => 'nonstandard');
+                    $row->cells[] = $source;
+
+                    // Other cells are blank.
+                    $row->cells[] = new html_table_cell('');
+                    $row->cells[] = new html_table_cell('');
+                    $row->cells[] = new html_table_cell('');
+                    $row->attributes = array('class' => 'deleted');
+                } else {
+                    if (!$restricted) {
+                        // Edit icons. For accessibility, the name of these links should
+                        // be different for each row, so we have to include the extension.
+                        $editurl = new \moodle_url('/admin/tool/filetypes/edit.php',
+                                array('oldextension' => $extension));
+                        $editbutton = html_writer::link($editurl, $this->pix_icon('t/edit',
+                                get_string('edita', '', s($extension))));
+                        $deleteurl = new \moodle_url('/admin/tool/filetypes/delete.php',
+                                array('extension' => $extension));
+                        $deletebutton = html_writer::link($deleteurl, $this->pix_icon('t/delete',
+                                get_string('deletea', 'tool_filetypes', s($extension))));
+                        $row->cells[] = new html_table_cell($editbutton . '&nbsp;' . $deletebutton);
+                    }
+
+                    // Source.
+                    $sourcestring = 'source_';
+                    if (!empty($filetype['custom'])) {
+                        $sourcestring .= 'custom';
+                    } else if (!empty($filetype['modified'])) {
+                        $sourcestring .= 'modified';
+                    } else {
+                        $sourcestring .= 'standard';
+                    }
+                    $source = new html_table_cell(get_string($sourcestring, 'tool_filetypes') .
+                            ($sourcestring === 'source_modified' ? ' ' . $revertbutton : ''));
+                    if ($sourcestring !== 'source_standard') {
+                        $source->attributes = array('class' => 'nonstandard');
+                    }
+                    $row->cells[] = $source;
+
+                    // MIME type.
+                    $mimetype = html_writer::div(s($filetype['type']), 'mimetype');
+                    if (!empty($filetype['defaulticon'])) {
+                        // Include the 'default for MIME type' info in the MIME type cell.
+                        $mimetype .= html_writer::div(html_writer::tag('i',
+                                get_string('defaulticon', 'tool_filetypes')));
+                    }
+                    $row->cells[] = new html_table_cell($mimetype);
+
+                    // Groups.
+                    $groups = !empty($filetype['groups']) ? implode(', ', $filetype['groups']) : '';
+                    $row->cells[] = new html_table_cell(s($groups));
+
+                    // Description.
+                    $description = get_mimetype_description(array('filename' => 'a.' . $extension));
+                    // Don't show the description if it's just a copy of the MIME type,
+                    // it makes the table ugly with the long duplicate text; leave blank instead.
+                    if ($description === $filetype['type']) {
+                        $description = '';
+                    }
+                    $row->cells[] = new html_table_cell($description);
+                }
+
+                $table->data[] = $row;
+            }
+            $out .= html_writer::table($table);
+        } else {
+            $out .= html_writer::tag('div', get_string('emptylist', 'tool_filetypes'));
+        }
+        // Displaying the 'Add' button.
+        if (!$restricted) {
+            $out .= $this->single_button(new moodle_url('/admin/tool/filetypes/edit.php',
+                    array('name' => 'add')), get_string('addfiletypes', 'tool_filetypes'), 'get');
+        }
+        return $out;
+    }
+}
diff --git a/admin/tool/filetypes/revert.php b/admin/tool/filetypes/revert.php
new file mode 100644
index 00000000000..549f460371d
--- /dev/null
+++ b/admin/tool/filetypes/revert.php
@@ -0,0 +1,60 @@
+<?php
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+/**
+ * Resets a file type to the default Moodle values.
+ *
+ * @package tool_filetypes
+ * @copyright 2014 The Open University
+ * @license http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+
+require(__DIR__ . '/../../../config.php');
+require_once($CFG->libdir . '/adminlib.php');
+
+admin_externalpage_setup('tool_filetypes');
+
+$extension = required_param('extension', PARAM_RAW);
+$redirecturl = new \moodle_url('/admin/tool/filetypes/index.php');
+
+if (optional_param('revert', 0, PARAM_INT)) {
+    require_sesskey();
+
+    // Reset the file type in config.
+    core_filetypes::revert_type_to_default($extension);
+    redirect($redirecturl);
+}
+
+// Page settings.
+$title = get_string('revertfiletype', 'tool_filetypes');
+
+$context = context_system::instance();
+$PAGE->set_url(new \moodle_url('/admin/tool/filetypes/revert.php', array('extension' => $extension)));
+$PAGE->navbar->add($title);
+$PAGE->set_context($context);
+$PAGE->set_pagelayout('admin');
+$PAGE->set_title($SITE->fullname. ': ' . $title);
+
+// Display the page.
+echo $OUTPUT->header();
+
+$message = get_string('revert_confirmation', 'tool_filetypes', $extension);
+$reverturl = new \moodle_url('revert.php', array('extension' => $extension, 'revert' => 1));
+$yesbutton = new single_button($reverturl, get_string('yes'));
+$nobutton = new single_button($redirecturl, get_string('no'), 'get');
+echo $OUTPUT->confirm($message, $yesbutton, $nobutton);
+
+echo $OUTPUT->footer();
diff --git a/admin/tool/filetypes/settings.php b/admin/tool/filetypes/settings.php
new file mode 100644
index 00000000000..2028b0dd1e7
--- /dev/null
+++ b/admin/tool/filetypes/settings.php
@@ -0,0 +1,31 @@
+<?php
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+/**
+ * Configure the setting page of the custom file type as an external page.
+ *
+ * @package tool_filetypes
+ * @copyright 2014 The Open University
+ * @license http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+
+defined('MOODLE_INTERNAL') || die;
+
+if ($hassiteconfig) {
+    $ADMIN->add('server', new admin_externalpage('tool_filetypes',
+            new lang_string('pluginname', 'tool_filetypes'),
+            $CFG->wwwroot . '/admin/tool/filetypes/index.php'));
+}
diff --git a/admin/tool/filetypes/tests/behat/add_filetypes.feature b/admin/tool/filetypes/tests/behat/add_filetypes.feature
new file mode 100644
index 00000000000..18d043e91c2
--- /dev/null
+++ b/admin/tool/filetypes/tests/behat/add_filetypes.feature
@@ -0,0 +1,107 @@
+@tool @tool_filetypes
+Feature: Add customised file types
+  In order to support a file mime type which doesn't exist in Moodle
+  As an administrator
+  I need to add a new customised file type
+
+  Scenario: Add a new file type
+    Given I log in as "admin"
+    And I navigate to "File types" node in "Site administration > Server"
+    And I press "Add"
+    # Try setting all the form fields, not just the optional ones.
+    And I set the following fields to these values:
+      | Extension                  | frog                                      |
+      | MIME type                  | application/x-frog                        |
+      | File icon                  | archive                                   |
+      | Type groups                | document                                  |
+      | Description type           | Custom description specified in this form |
+      | Custom description         | Froggy file                               |
+      | Default icon for MIME type | 1                                         |
+    When I press "Save changes"
+    Then I should see "Froggy file" in the "application/x-frog" "table_row"
+    And I should see "document" in the "application/x-frog" "table_row"
+    And I should see "frog" in the "application/x-frog" "table_row"
+    And "//img[contains(@src, 'archive')]" "xpath_element" should exist in the "application/x-frog" "table_row"
+
+  Scenario: Update an existing file type
+    Given I log in as "admin"
+    And I navigate to "File types" node in "Site administration > Server"
+    When I click on "Edit 7z" "link"
+    And I set the following fields to these values:
+      | Extension | doc |
+    And I press "Save changes"
+    Then I should see "File extensions must be unique"
+    And I set the following fields to these values:
+      | Extension | frog |
+    And I press "Save changes"
+    And I should see "frog" in the "application/x-7z-compressed" "table_row"
+
+  Scenario: Delete an existing file type
+    Given I log in as "admin"
+    And I navigate to "File types" node in "Site administration > Server"
+    When I click on "Delete 7z" "link"
+    Then I should see "Are you absolutely sure you want to remove .7z?"
+    And I press "Yes"
+    And I should see "Deleted" in the "7z" "table_row"
+
+  Scenario: Delete a custom file type
+    Given I log in as "admin"
+    And I navigate to "File types" node in "Site administration > Server"
+    And I press "Add"
+    And I set the following fields to these values:
+      | Extension                  | frog                                      |
+      | MIME type                  | application/x-frog                        |
+    And I press "Save changes"
+    When I click on "Delete frog" "link"
+    And I press "Yes"
+    Then I should not see "frog"
+
+  Scenario: Revert changes to deleted file type
+    Given I log in as "admin"
+    And I navigate to "File types" node in "Site administration > Server"
+    When I click on "Delete 7z" "link"
+    And I press "Yes"
+    And I follow "Restore 7z to Moodle defaults"
+    And I press "Yes"
+    Then I should not see "Deleted" in the "7z" "table_row"
+
+  Scenario: Revert changes to updated file type
+    Given I log in as "admin"
+    And I navigate to "File types" node in "Site administration > Server"
+    And I click on "Edit 7z" "link"
+    And I set the following fields to these values:
+      | File icon | document |
+    And I press "Save changes"
+    When I follow "Restore 7z to Moodle defaults"
+    And I press "Yes"
+    Then "//img[contains(@src, 'archive')]" "xpath_element" should exist in the "7z" "table_row"
+
+  @javascript
+  Scenario: Create a resource activity which contains a customised file type
+    Given the following "courses" exist:
+      | fullname | shortname |
+      | Course 1 | C1        |
+    And I log in as "admin"
+    And I navigate to "File types" node in "Site administration > Server"
+    And I press "Add"
+    And I set the following fields to these values:
+      | Extension          | frog                                      |
+      | MIME type          | application/x-frog                        |
+      | File icon          | archive                                   |
+      | Description type   | Custom description specified in this form |
+      | Custom description | Froggy file                               |
+    And I press "Save changes"
+    # Create a resource activity and add it to a course
+    And I am on homepage
+    And I follow "Course 1"
+    And I turn editing mode on
+    When I add a "File" to section "1"
+    And I set the following fields to these values:
+      | Name        | An example of customised file type |
+      | Description | File description                   |
+    And I upload "admin/tool/filetypes/tests/fixtures/test.frog" file to "Select files" filemanager
+    And I expand all fieldsets
+    And I set the field "Show type" to "1"
+    And I press "Save and return to course"
+    Then I should see "Froggy file"
+    And the "src" attribute of ".modtype_resource a img" "css_element" should contain "archive"
diff --git a/admin/tool/filetypes/tests/fixtures/test.frog b/admin/tool/filetypes/tests/fixtures/test.frog
new file mode 100644
index 00000000000..f9819bb6649
--- /dev/null
+++ b/admin/tool/filetypes/tests/fixtures/test.frog
@@ -0,0 +1 @@
+This is not a real file format.
\ No newline at end of file
diff --git a/admin/tool/filetypes/tests/tool_filetypes_test.php b/admin/tool/filetypes/tests/tool_filetypes_test.php
new file mode 100644
index 00000000000..6d536835d4e
--- /dev/null
+++ b/admin/tool/filetypes/tests/tool_filetypes_test.php
@@ -0,0 +1,86 @@
+<?php
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+/**
+ * Unit tests for the custom file types.
+ *
+ * @package tool_filetypes
+ * @copyright 2014 The Open University
+ * @license http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+
+defined('MOODLE_INTERNAL') || die();
+
+use tool_filetypes\utils;
+
+/**
+ * Unit tests for the custom file types.
+ *
+ * @package tool_filetypes
+ * @copyright 2014 The Open University
+ * @license http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+class tool_filetypes_test extends advanced_testcase {
+    /**
+     * Tests is_extension_invalid() function.
+     */
+    public function test_is_extension_invalid() {
+        // The pdf file extension already exists in default moodle minetypes.
+        $this->assertTrue(utils::is_extension_invalid('pdf'));
+
+        // The frog extension does not.
+        $this->assertFalse(utils::is_extension_invalid('frog'));
+
+        // However you could use the pdf extension when editing the pdf extension.
+        $this->assertFalse(utils::is_extension_invalid('pdf', 'pdf'));
+
+        // Blank extension is invalid.
+        $this->assertTrue(utils::is_extension_invalid(''));
+
+        // Extensions with dot are invalid.
+        $this->assertTrue(utils::is_extension_invalid('.frog'));
+    }
+
+    /**
+     * Tests is_defaulticon_allowed() function.
+     */
+    public function test_is_defaulticon_allowed() {
+        // You ARE allowed to set a default icon for a MIME type that hasn't
+        // been used yet.
+        $this->assertTrue(utils::is_defaulticon_allowed('application/x-frog'));
+
+        // You AREN'T allowed to set default icon for text/plain as there is
+        // already a type that has that set.
+        $this->assertFalse(utils::is_defaulticon_allowed('text/plain'));
+
+        // But you ARE still allowed to set it when actually editing txt, which
+        // is the default.
+        $this->assertTrue(utils::is_defaulticon_allowed('text/plain', 'txt'));
+    }
+
+    /**
+     * Tests get_icons_from_path() function.
+     */
+    public function test_get_icons_from_path() {
+        // Get icons from the fixtures folder.
+        $icons = utils::get_icons_from_path(__DIR__ . '/fixtures');
+
+        // The icons are returned alphabetically and with keys === values.
+        // For the icon with numbers after the name, only the base name is
+        // returned and only one of it.
+        $this->assertEquals(array('frog' => 'frog', 'zombie' => 'zombie'), $icons);
+    }
+}
diff --git a/admin/tool/filetypes/version.php b/admin/tool/filetypes/version.php
new file mode 100644
index 00000000000..c9a67d5d7be
--- /dev/null
+++ b/admin/tool/filetypes/version.php
@@ -0,0 +1,29 @@
+<?php
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+/**
+ * Version details.
+ *
+ * @package tool_filetypes
+ * @copyright 2014 The Open University
+ * @license http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+
+defined('MOODLE_INTERNAL') || die();
+
+$plugin->version = 2014051220;
+$plugin->requires = 2014051220;
+$plugin->component = 'tool_filetypes';
-- 
2.17.1


